import { EventEmitter } from '@angular/core';
import { ControlValueAccessor, NgControl } from '@angular/forms';
export declare class NtCheckboxChange<T> {
    source: NtCheckboxComponent<T>;
    checked: boolean;
    constructor(source: NtCheckboxComponent<T>, checked: boolean);
}
export declare class NtCheckboxComponent<T> implements ControlValueAccessor {
    ngControl: NgControl;
    readonly id: string;
    private _value;
    private _disabled;
    private _readonly;
    private _checked;
    tabIndex: number;
    value: T | null;
    disabled: boolean;
    readonly: boolean;
    checked: boolean;
    readonly change: EventEmitter<NtCheckboxChange<T>>;
    private _onChange;
    private _onTouched;
    constructor(tabIndex: string, ngControl: NgControl);
    writeValue(value: T): void;
    registerOnChange(fn: (_: any) => {}): void;
    registerOnTouched(fn: () => {}): void;
    setDisabledState(isDisabled: boolean): void;
    _onInputClick(event: Event): void;
    private _emitChangeEvent();
}
