import { CdkOverlayOrigin } from '@angular/cdk/overlay';
import { Component, ElementRef, EventEmitter, Input, Output, ViewChild, ViewEncapsulation, TemplateRef, NgModule } from '@angular/core';
import { NtOverlayComponent, NtOverlayModule } from '@ng-tangram/components/core';
import { CommonModule } from '@angular/common';
import { NtButtonModule } from '@ng-tangram/components/button';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class NtPopConfirmComponent {
    /**
     * @param {?} _elementRef
     */
    constructor(_elementRef) {
        this._elementRef = _elementRef;
        this._title = '';
        this.position = 'top';
        this.confirmText = '确认';
        this.cancelText = '取消';
        this.confirm = new EventEmitter();
        this.cancel = new EventEmitter();
        this.origin = new CdkOverlayOrigin(this._elementRef);
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set title(value) { this._title = value; }
    /**
     * @return {?}
     */
    get title() { return this._title; }
    /**
     * @param {?} value
     * @return {?}
     */
    set template(value) { this._template = value; }
    /**
     * @return {?}
     */
    get template() { return this._template; }
    /**
     * @param {?} value
     * @return {?}
     */
    set _default(value) {
        if (value instanceof TemplateRef) {
            this._template = value;
        }
        else {
            this._title = value;
            this._template = null;
        }
    }
    /**
     * @param {?} isConfirm
     * @return {?}
     */
    _closeOverlay(isConfirm) {
        (isConfirm ? this.confirm : this.cancel).emit();
        this.overlay.hide();
    }
}
NtPopConfirmComponent.decorators = [
    { type: Component, args: [{
                selector: '[nt-popconfirm]',
                template: "<ng-content></ng-content> <nt-overlay [origin]=\"origin\" [position]=\"position\" trigger=\"click\" arrow> <div class=\"nt-popconfirm\"> <div class=\"nt-popconfirm-title\" *ngIf=\"template\"><ng-container *ngTemplateOutlet=\"template\"></ng-container></div> <div class=\"nt-popconfirm-title\" *ngIf=\"!template\" [innerHtml]=\"title\"></div> <div class=\"nt-popconfirm-action\"> <button nt-button color=\"secondary\" size=\"tiny\" (click)=\"_closeOverlay(false)\">{{cancelText}}</button> <button nt-button size=\"tiny\" (click)=\"_closeOverlay(true)\">{{confirmText}}</button> </div> </div> </nt-overlay> ",
                encapsulation: ViewEncapsulation.None,
                host: {
                    '(click)': 'overlay.click()'
                }
            },] },
];
/** @nocollapse */
NtPopConfirmComponent.ctorParameters = () => [
    { type: ElementRef, },
];
NtPopConfirmComponent.propDecorators = {
    "title": [{ type: Input },],
    "template": [{ type: Input },],
    "_default": [{ type: Input, args: ['nt-popconfirm',] },],
    "position": [{ type: Input },],
    "confirmText": [{ type: Input },],
    "cancelText": [{ type: Input },],
    "confirm": [{ type: Output },],
    "cancel": [{ type: Output },],
    "overlay": [{ type: ViewChild, args: [NtOverlayComponent,] },],
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class NtPopConfirmModule {
}
NtPopConfirmModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule, NtOverlayModule, NtButtonModule],
                exports: [NtPopConfirmComponent],
                declarations: [NtPopConfirmComponent]
            },] },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

export { NtPopConfirmModule, NtPopConfirmComponent };
//# sourceMappingURL=popconfirm.js.map
